import firebase from 'firebase/app';
import { LoadingHook } from '../util';
export declare type DocumentOnceHook<T> = LoadingHook<firebase.firestore.DocumentSnapshot<T>, Error>;
export declare type DocumentDataOnceHook<T> = LoadingHook<T, Error>;
export declare const useDocumentOnce: <T>(docRef?: firebase.firestore.DocumentReference<firebase.firestore.DocumentData> | null | undefined, options?: {
    getOptions?: firebase.firestore.GetOptions | undefined;
} | undefined) => [firebase.firestore.DocumentSnapshot<T> | undefined, boolean, Error | undefined];
export declare const useDocumentDataOnce: <T>(docRef?: firebase.firestore.DocumentReference<firebase.firestore.DocumentData> | null | undefined, options?: {
    getOptions?: firebase.firestore.GetOptions | undefined;
    idField?: string | undefined;
    refField?: string | undefined;
} | undefined) => [T | undefined, boolean, Error | undefined];
